Option Explicit
'On Error Resume Next

Dim rs
Dim dbConn
Dim Action
Dim FileName 
Dim szList
Dim RECCSN
Dim RECGRP
Dim RECCSN1
Dim RECGRP1
Dim RCNM
Dim Data

FileName   = GetPropertyValue( "Recipes.PathAndFileName" )
Set dbConn = CreateObject( "ADODB.Connection" ) 
dbConn.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & FileName

'===============================================================================================
'Continuous running script
Do
	Sleep 1
	Action = GetPropertyValue("Recipes.Action")
		If Action <> "Waiting" Then
		SetPropertyValue "Recipes.Action", "Waiting"
		Call Handle_RecipeAction(Action)
		Sleep 50
	End If
Loop

' Reset
Set rs       = Nothing
Set FileName = Nothing
Set dbConn   = Nothing
 
'======================================================================================================
Sub Handle_RecipeAction(Action)

 
	Data = Split(Action, "^")
	Select Case Data(0)
		Case "UPD"  : Call Update
		Case "NM"  : Call LIST_RECNAME
		Case "CSNE"  : Call LIST_RECCSNE
		Case "KEYINGRED" : Call LIST_RECGRP
		Case "Name": Call HandleName(Data(1))
		Case "Food" : Call PANELchangeGrp(Data(1))
		Case "CUISINE" : Call PANELchangeCSN(Data(1))
		End Select
	End Sub
 '======================================================================================================
Sub Update
Dim rs1
Dim FileName1
Dim dbConn1

FileName1   = "C:\Program Files\HouseBot\Config\HBData.mdb"
Set dbConn1 = CreateObject( "ADODB.Connection" ) 
dbConn1.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & FileName1

Set rs1 = dbConn1.Execute("DELETE FROM AlphaList WHERE ListData LIKE 'Name^%'")
Set rs1 = dbConn1.Execute("DELETE FROM AlphaList WHERE ListData LIKE 'CUISINE^%'")
Set rs1 = dbConn1.Execute("DELETE FROM AlphaList WHERE ListData LIKE 'Food^%'")
SetPropertyValue "Recipes.RECIPESKEYINGRED", "Updating......"
SetPropertyValue "Recipes.RECIPESCSN", "Updating......."
SetPropertyValue "Recipes.Ingredients", "PLEASE SELECT A RECIPE......."
SetPropertyValue "Recipes.SubList", "NO DATA YET......."
SetPropertyValue "Recipes.Name List", "Name List is Updating......."
OpenRemotePanel "RECIPES"

Set rs1       = Nothing
Set FileName1 = Nothing
Set dbConn1   = Nothing

'=====================================
'Populates the RecipesCuisine List fields.
Set rs = dbConn.Execute("SELECT DISTINCT [Cuisine] FROM Recipes ORDER BY [Cuisine]") 
Do
RECCSN = RECCSN & "CUISINE^" &  rs("Cuisine") &  vbTab & rs("Cuisine") & vbLF
rs.MoveNext
Loop Until rs.EOF
Set rs = Nothing
SetPropertyValue "Recipes.RECIPESCSN", RECCSN

'=====================================
'Populates the RecipesKeyIngredient List fields.
Set rs = dbConn.Execute( "SELECT DISTINCT [Key Ingredient] FROM Recipes ORDER BY [Key Ingredient]") 
Do 
RECGRP = RECGRP & "Food^" &  rs("Key Ingredient") &  vbTab & rs("Key Ingredient") & vbLF
'MsgBox RECGRP
rs.MoveNext
Loop Until rs.EOF
Set rs = Nothing
SetPropertyValue "Recipes.RECIPESKEYINGRED", RECGRP

'=====================================
'Populates the RecipesName List fields.
Set rs = dbConn.Execute( "SELECT DISTINCT Name FROM Recipes ORDER BY Name") 
Do
 szList = szList & "Name^" &  rs("Name") &  vbTab & rs("Name") & vbLF
 rs.MoveNext
Loop Until rs.EOF
Set rs = Nothing
SetPropertyValue "Recipes.Name List", szList

'===================================
'Removes Null Value from selected columns

Set rs = dbConn.Execute("UPDATE [Recipes] SET Serves = '1' WHERE Serves IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Cuisine = '-' WHERE Cuisine IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Ingredients = '-' WHERE Ingredients IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Instructions = '-' WHERE Instructions IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET [Key Ingredient] = '-' WHERE [Key Ingredient] IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Courses = '-' WHERE Courses IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Meals = '-' WHERE Meals IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET [Food Group] = '-' WHERE [Food Group] IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Preparation = '-' WHERE Preparation IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Temperature = '-' WHERE Temperature IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Effort = '-' WHERE Effort IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET [Preparation Time] = '-' WHERE [Preparation Time] IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET [Elapsed Time] = '-' WHERE [Elapsed Time] IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Occasion = '-' WHERE Occasion IS NULL ")
Set rs = dbConn.Execute("UPDATE [Recipes] SET Comments = '-' WHERE Comments IS NULL ")
Set rs = Nothing
End Sub
'=============================================================================================
'When "NM" is in the property change button it switches the list box (Name List)
Sub LIST_RECNAME
RCNM = GetPropertyValue("Recipes.RECIPESALL")
SetPropertyValue "Recipes.Name List", RCNM
End Sub
'===============
'When "CSNE" is in the property change button it switches the list box (SubList)
Sub LIST_RECCSNE
RECCSN1 = GetPropertyValue("Recipes.RECIPESCSN")
SetPropertyValue "Recipes.SubList", RECCSN1
End Sub
'===============
'When "KEYINGRED" is in the property change button it switches the list box (SubList)
Sub LIST_RECGRP
RECGRP1 = GetPropertyValue("Recipes.RECIPESKEYINGRED")
SetPropertyValue "Recipes.SubList", RECGRP1
End Sub
'=================================================================================================
Sub HandleName(Data)
Set rs = dbConn.Execute("SELECT Ingredients, Instructions, Cuisine FROM [Recipes] WHERE Name = '" & Data & "'")
SetPropertyValue "Recipes.Ingredients", rs("Ingredients")
SetPropertyValue "Recipes.Instructions", rs("Instructions")
SetPropertyValue "Recipes.Cuisine", rs("Cuisine")
Set rs = Nothing
End Sub
'===================================================================================================
Sub PANELchangeGrp(Data)
Dim PLGRP
Set rs = dbConn.Execute("SELECT Name FROM [Recipes] WHERE [Key Ingredient] = '" & Data & "' ORDER BY Name")
Do
PLGRP = PLGRP & "Name^" &  rs("Name") &  vbTab & rs("Name") & vbLF
'MsgBox PLGRP
rs.MoveNext
Loop Until rs.EOF
Set rs = Nothing
SetPropertyValue "Recipes.SubList", PLGRP
End Sub
'===================================
Sub PANELchangeCSN(Data)
Dim PLCSN
Set rs = dbConn.Execute("SELECT Name FROM [Recipes] WHERE [Cuisine] = '" & Data & "' ORDER BY Name")
Do
PLCSN = PLCSN & "Name^" &  rs("Name") &  vbTab & rs("Name") & vbLF
'MsgBox PLCSN
rs.MoveNext
Loop Until rs.EOF
Set rs = Nothing
SetPropertyValue "Recipes.SubList", PLCSN
End Sub
'================================================================================================

